<?php
class dev_docbuilder_ad_md
{

    public function gendoc($api)
    {
        return $this->genMarkdown($api);
    }

    public function genindex($index)
    {
        $md = '';
        $md .= $this->__genTitle1($index);
        $md .= $this->__genTitle2($index);
        $md .= $this->__genIndex($index['index']);

        return $md;
    }

    public function genMarkdown($api)
    {
        $markdown  = '';
        $markdown .= $this->__genTitle1($api);
        $markdown .= $this->__genTitle2($api);
        $markdown .= $this->__genTitle3($api);
        $markdown .= $this->__genParams($api);
        $markdown .= $this->__genResponse($api);

        return $markdown;
    }

    private function __genIndex($index)
    {
        $ret = '';
        foreach($index as $k=>$v)
        {
            $ret .= $this->__genLink($v, $k);
        }
        return $ret;
    }

    private function __genTitle1($api)
    {
        $title = $api['title1'];
        $title = '# '. $title . "\n\n";
        return $title;
    }

    private function __genTitle2($api)
    {
        $title = $api['title2'];
        $title = '## '. $title . "\n\n";
        return $title;
    }

    private function __genTitle3($api)
    {
        $title = $api['title3'];
        $title = '### '. $title . "\n\n";
        return $title;
    }

    private function __genParams($api)
    {
        //传入参数
        //先搞定系统参数
        $systemParams = $api['system_params'];
        $requestParams = $api['params'];
        $title = $api['request_title'];

        $table1 = "* 系统参数\n\n";
        $table1 .= $this->__genTable($systemParams, $title);


        $table2 = "* 业务参数\n\n";
        $table2 .= $this->__genTable($requestParams, $title);

        $endTable = $table1 . "\n\n" .$table2 . "\n\n";

        return $endTable;
    }

    private function __genResponse($api)
    {
        $response = "*返回内容示例\n\n```\n\n" . $api['response'] . "\n\n```\n\n";

        return $response;
    }

    private function __genTable($arr, $title)
    {
        $keys = array();
        $titles = array();
        foreach($title as $key=>$value)
        {
            $keys[] = $key;
        }


        //生成表头
        $firstLine = '|';
        $secondLine = '|';

        foreach($keys as $k)
        {
            $firstLine  .= ' *' . $title[$k] . '* |';
            $secondLine .= ' ------------- |';
        }
        $tableHeader = $firstLine . "\n" . $secondLine . "\n";

        foreach($arr as $line)
        {
            $tableHeader .= '|';
            foreach($keys as $k)
            {
                $tableHeader .= ' ' . $this->__removeRSS($line[$k]) . ' |';
            }
            $tableHeader .= "\n";
        }

        return $tableHeader;
    }

    private function __genLink($title, $file)
    {
        return '- ['.$title.']('.$file.')'. "\n";
    }

    private function __removeRSS($string)
    {
        $s = str_replace('|', ',', $string);
        return $s;
    }


}
