<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2014-2014 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */

class sysuser_data_user_user
{
	/**
     * 会员中心用户个人资料修改
     * @param string user id
     * @param
     * @param array postdata 不能为空
     * @return boolean true or false
     */
	public function saveInfoSet($postdata,$userId)
	{

		$this->checkPost($postdata,$userId);
		$sysdata = array(
			'user_id'=>$postdata['user']['user_id'],
			'sex'=>$postdata['user']['sex'],
			'name'=>$postdata['user']['name'],
			'birthday'=>strtotime($postdata['user']['birthday']),
			'area'=>$postdata['area'],
			'addr'=>$postdata['user']['addr'],
			'username'=>$postdata['user']['username'],
		);

		if( !app::get('sysuser')->model('user')->save($sysdata) )
		{
			throw new \LogicException(app::get('sysuser')->_('修改失败'));
		}

		return true;
	}

	function checkPost($postdata,$userId)
	{
		if(!$userId)
		{
			throw new \LogicException(app::get('sysuser')->_('缺少参数!'));
		}
		if(empty($postdata['user']['name']))
		{
			throw new \LogicException(app::get('sysuser')->_('用户昵称不能为空!'));
		}
		if(empty($postdata['user']['username']))
		{
			throw new \LogicException(app::get('sysuser')->_('用户姓名不能为空!'));
		}
		if( strlen(trim($postdata['user']['name']))< 4 || strlen(trim($postdata['user']['name']))>20)
		{
			throw new \LogicException(app::get('sysuser')->_('用户昵称最少4个字符,最多20个字符!'));
		}

		if( strlen(trim($postdata['user']['username'])) > 20 )
		{
			throw new \LogicException(app::get('sysuser')->_('用户姓名过长,请输入20个英文或10个汉字!'));
		}
		return true;
	}

}
